//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern double BarRatio      = 0.333333;
extern bool   ViewAsCandles = false;
extern int    WickWidth     = 1;
extern int    BodyWidth     = 2;

double barwu[];
double barwd[];
double barbu[];
double barbd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (ViewAsCandles) type = DRAW_HISTOGRAM;
   SetIndexBuffer(0,barwu); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(1,barwd); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(2,barbu); SetIndexStyle(2,type          ,EMPTY,BodyWidth);
   SetIndexBuffer(3,barbd); SetIndexStyle(3,type          ,EMPTY,BodyWidth);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
      for(int i = limit; i >= 0; i--)
      {
         barwu[i] = EMPTY_VALUE;
         barwd[i] = EMPTY_VALUE;
         barbu[i] = EMPTY_VALUE;
         barbd[i] = EMPTY_VALUE;
            double range = High[i]-Low[i];
            double diffh = High[i]-Close[i];
            double diffl = Close[i]-Low[i];
               if (diffh <= range*BarRatio) 
               {
                  barwu[i] = High[i];
                  barwd[i] = Low[i];
                  barbu[i] = MathMax(Open[i],Close[i]);
                  barbd[i] = MathMin(Open[i],Close[i]);
               }
               if (diffl <= range*BarRatio) 
               {
                  barwd[i] = High[i];
                  barwu[i] = Low[i];
                  barbu[i] = MathMin(Open[i],Close[i]);
                  barbd[i] = MathMax(Open[i],Close[i]);
               }
      }
   return(0);
}